/*
GEST - Gameboy emulator
Copyright (C) 2003-2004 TM

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
 
// cpu emulation code #included to mainloop.c

   byte temp = 0x00;
   word tempreg; 
   tempreg.W = 0x0000;
   signed char offset = 0x00;
   int carry = 0;
      
   switch(opcode)
   { 
      case 0x00: //NOP
      case 0x7f: //LD A,A
      case 0x40: //LD B,B
      case 0x49: //LD C,C
      case 0x52: //LD D,D
      case 0x5b: //LD E,E
      case 0x64: //LD H,H
      case 0x6d: //LD L,L
      break;
      
      case 0x01: //LD BC,xxxx
       BC.W = readword(PC.W);
       PC.W += 2;      
      break;
      case 0x02: //LD (BC),A
        writememory(BC.W,A);
      break;
      case 0x03: //INC BC
        ++BC.W;
      break;
      case 0x04: //INC B
        gbz80_inc(&BC.B.h);
      break;
      case 0x05: //DEC B
        gbz80_dec(&BC.B.h);
      break;
      case 0x06: //LD B,xx
        BC.B.h = readopcode(PC.W++);
      break;
      case 0x07: //RLCA
        gbz80_rlca();   
      break;
      case 0x08: //LD (xxxx),SP 
        writeword(readword(PC.W),SP.W);
        PC.W += 2;              
      break;
      case 0x09: //ADD HL,BC
       gbz80_add16(&HL.W,BC.W);
      break;
      case 0x0A: //LD A,(BC)
        A = readmemory(BC.W);
      break;
      case 0x0B: //DEC BC
        --BC.W;
      break;
      case 0x0C: //INC C
        gbz80_inc(&BC.B.l);
      break;
      case 0x0D: //DEC C
        gbz80_dec(&BC.B.l);
      break;    
      case 0x0E: //LD C,xx
        BC.B.l = readopcode(PC.W++);
      break;
      case 0x0F: //RRCA
        gbz80_rrca();
      break;
      case 0x10: //STOP
        ++PC.W; 

        if(GB->gbc_mode && (GB->memory[0xFF4D] & 0x01)) // GBC speed switch
        {
           GB->gb_speed = !GB->gb_speed;
           
           GB->memory[0xFF4D] = (GB->gb_speed?0x80:0x00);
        }
      break;
      case 0x11: //LD DE,xxxx
        DE.W = readword(PC.W);
        PC.W += 2;           
      break;
      case 0x12: //LD (DE),A
        writememory(DE.W,A);
      break;
      case 0x13: //INC DE
        ++DE.W;
      break;
      case 0x14: //INC D
        gbz80_inc(&DE.B.h);
      break;
      case 0x15: //DEC D
        gbz80_dec(&DE.B.h);
      break;
      case 0x16: //LD D,xx
        DE.B.h = readopcode(PC.W++);
      break;
      case 0x17: //RLA
        gbz80_rla();
      break;
      case 0x18: //JR xx
        PC.W += (signed char)readopcode(PC.W)+1;
      break;
      case 0x19: //ADD HL,DE
       gbz80_add16(&HL.W,DE.W);
      break;
      case 0x1A: //LD A,(DE)
        A = readmemory(DE.W);
      break;
      case 0x1B: //DEC DE
        --DE.W;
      break;
      case 0x1C: //INC E
        gbz80_inc(&DE.B.l);
      break;
      case 0x1D: //DEC E
        gbz80_dec(&DE.B.l);
      break;
      case 0x1E: //LD E,xx
        DE.B.l = readopcode(PC.W++);
      break;
      case 0x1F: //RRA
        gbz80_rra();
      break;
      case 0x20: //JR NZ,xx
        if(!(flags&0x4000)) 
        { 
           cur_cycle = 12; 
           PC.W += (signed char)readopcode(PC.W)+1; 
        } else 
           ++PC.W;
      break;
      case 0x21: //LD HL,xxxx
        HL.W = readword(PC.W);
        PC.W += 2;           
      break;
      case 0x22: //"LD (HL+),A" "LD (HLI),A" LDI (HL),A
        writememory(HL.W,A); 
        ++HL.W;
      break;
      case 0x23: //INC HL
        ++HL.W;
      break;
      case 0x24: //INC H
        gbz80_inc(&HL.B.h);
      break;   
      case 0x25: //DEC H
        gbz80_dec(&HL.B.h);
      break;
      case 0x26: //LD H,xx
        HL.B.h = readopcode(PC.W++);
      break;
      case 0x27: //DAA // Decimal Adjust Accumulator
        if(NFLAG) // adjust for substraction
           gbz80_das();
        else
           gbz80_daa();
      break;
      case 0x28: //JR Z,xx
        if(flags&0x4000) 
        { 
           cur_cycle = 12; 
           PC.W += (signed char)readopcode(PC.W)+1; 
        } else
           ++PC.W;
      break;
      case 0x29: //ADD HL,HL
       gbz80_add16(&HL.W,HL.W);
      break;
      case 0x2A: //LDI A,(HL) "LD A,(HL+)" "LD A,(HLI)"
        A = readmemory(HL.W); 
        ++HL.W;
      break;
      case 0x2B: //DEC HL
        --HL.W;
      break;
      case 0x2C: //INC L
        gbz80_inc(&HL.B.l);
      break;
      case 0x2D: //DEC L
        gbz80_dec(&HL.B.l);
      break;
      case 0x2E: //LD L,xx
        HL.B.l = readopcode(PC.W++);
      break;
      case 0x2F: //CPL
        gbz80_cpl();
      break;
      case 0x30: //JR NC,xx
        if(!(flags&0x0100)) 
        { 
           cur_cycle = 12; 
           PC.W += (signed char)readopcode(PC.W)+1; 
        } else 
           ++PC.W;
      break;
      case 0x31: //LD SP,xxxx
        SP.W = readword(PC.W);
        PC.W += 2;           
      break;
      case 0x32: //LDD (HL),A "LD (HL-),A" "LD (HLD),A"
        writememory(HL.W,A);
        --HL.W;
      break;
      case 0x33: //INC SP
        ++SP.W;
      break;
      case 0x34: //INC (HL)
        temp = readmemory(HL.W);
        gbz80_inc(&temp); 
        writememory(HL.W,temp);
      break;
      case 0x35: //DEC (HL)
        temp = readmemory(HL.W);
        gbz80_dec(&temp); 
        writememory(HL.W,temp);
      break;   
      case 0x36: //LD (HL),xx
        writememory(HL.W,readopcode(PC.W++));
      break;
      case 0x37: //SCF Set Carry Flag
        gbz80_scf();
      break;
      case 0x38: //JR C,xx
        if(flags&0x0100) 
        { 
           cur_cycle = 12; 
           PC.W += (signed char)readopcode(PC.W)+1; 
        } else 
           ++PC.W;
      break;
      case 0x39: //ADD HL,SP
        gbz80_add16(&HL.W,SP.W);
      break;
      case 0x3A: //LDD A,(HL) "LD A,(HL-)" "LD A,(HLD)"
        A = readmemory(HL.W);
        --HL.W;
      break;
      case 0x3B: //DEC SP
        --SP.W;
      break;
      case 0x3C: //INC A
        gbz80_inc(&A);
      break;
      case 0x3D: //DEC A
        gbz80_dec(&A);
      break;
      case 0x3E: //LD A,xx
        A = readopcode(PC.W++);
      break;
      case 0x3F: //CCF
        gbz80_ccf();
      break;
      case 0x41: //LD B,C
        BC.B.h = BC.B.l;
      break;
      case 0x42: //LD B,D
        BC.B.h = DE.B.h;
      break;  
      case 0x43: //LD B,E    
        BC.B.h = DE.B.l;
      break;
      case 0x44: //LD B,H
        BC.B.h = HL.B.h;
      break;
      case 0x45: //LD B,L
        BC.B.h = HL.B.l;
      break;
      case 0x46: //LD B,(HL)
        BC.B.h = readmemory(HL.W);
      break;
      case 0x47: //LD B,A
        BC.B.h = A;
      break;
      case 0x48: //LD C,B
        BC.B.l = BC.B.h;
      break;
      case 0x4A: //LD C,D
        BC.B.l = DE.B.h;
      break;
      case 0x4B: //LD C,E
        BC.B.l = DE.B.l;
      break;
      case 0x4C: //LD C,H
        BC.B.l = HL.B.h;
      break;  
      case 0x4D: //LD C,L
        BC.B.l = HL.B.l;
      break;   
      case 0x4E: //LD C,(HL)
        BC.B.l = readmemory(HL.W);
      break;
      case 0x4F: //LD C,A
        BC.B.l = A;
      break;
      case 0x50: //LD D,B
        DE.B.h = BC.B.h;
      break;
      case 0x51: //LD D,C
        DE.B.h = BC.B.l;
      break;
      case 0x53: //LD D,E
        DE.B.h = DE.B.l;
      break;
      case 0x54: //LD D,H
        DE.B.h = HL.B.h;
      break;
      case 0x55: //LD D,L
        DE.B.h = HL.B.l;
      break;
      case 0x56: //LD D,(HL)
        DE.B.h = readmemory(HL.W);
      break;
      case 0x57: //LD D,A
        DE.B.h = A;
      break;
      case 0x58: //LD E,B
        DE.B.l = BC.B.h;
      break;
      case 0x59: //LD E,C
        DE.B.l = BC.B.l;
      break;
      case 0x5A: //LD E,D
        DE.B.l = DE.B.h;
      break;
      case 0x5C: //LD E,H
        DE.B.l = HL.B.h;
      break;
      case 0x5D: //LD E,L
        DE.B.l = HL.B.l;
      break;
      case 0x5E: //LD E,(HL)
        DE.B.l = readmemory(HL.W);
      break;
      case 0x5F: //LD E,A
        DE.B.l = A;
      break;
      case 0x60: //LD H,B
        HL.B.h = BC.B.h;
      break;
      case 0x61: //LD H,C
        HL.B.h = BC.B.l;
      break;
      case 0x62: //LD H,D
        HL.B.h = DE.B.h;
      break;
      case 0x63: //LD H,E
        HL.B.h = DE.B.l;
      break;
      case 0x65: //LD H,L
        HL.B.h = HL.B.l;
      break;
      case 0x66: //LD H,(HL)
        HL.B.h = readmemory(HL.W);
      break;
      case 0x67: //LD H,A
        HL.B.h = A;
      break;
      case 0x68: //LD L,B
        HL.B.l = BC.B.h;
      break;
      case 0x69: //LD L,C
        HL.B.l = BC.B.l;
      break;
      case 0x6A: //LD L,D
        HL.B.l = DE.B.h;
      break;
      case 0x6B: //LD L,E
        HL.B.l = DE.B.l;
      break;
      case 0x6C: //LD L,H
        HL.B.l = HL.B.h;
      break;
      case 0x6E: //LD L,(HL)
        HL.B.l = readmemory(HL.W);
      break;
      case 0x6F: //LD L,A
        HL.B.l = A;
      break;
      case 0x70: //LD (HL),B
        writememory(HL.W,BC.B.h);
      break;
      case 0x71: //LD (HL),C
        writememory(HL.W,BC.B.l);
      break;
      case 0x72: //LD (HL),D
        writememory(HL.W,DE.B.h);
      break;
      case 0x73: //LD (HL),E
        writememory(HL.W,DE.B.l);
      break;
      case 0x74: //LD (HL),H
        writememory(HL.W,HL.B.h);
      break;
      case 0x75: //LD (HL),L
        writememory(HL.W,HL.B.l);
      break;
      case 0x76: //HALT //  Halt CPU until interrupt        
        if(GB->IME || GB->EI_count == 1) // IME = 1 or last instruction was EI
        {
           GB->CPUHalt = HALT;
           GB->EI_count = 0;
           GB->IME = 1;
        }
        else if(GB->memory[0xFF0F]&GB->memory[0xFFFF])
           GB->CPUHalt = HALT2;     
        else if(GB->memory[0xFFFF]==0)
           GB->CPUHalt = HALT;  // freeze
      break;
      case 0x77: //LD (HL),A
        writememory(HL.W,A);
      break;
      case 0x78: //LD A,B
        A = BC.B.h;
      break;
      case 0x79: //LD A,C
        A = BC.B.l;
      break;
      case 0x7A: //LD A,D
        A = DE.B.h;
      break;
      case 0x7B: //LD A,E
        A = DE.B.l;
      break;
      case 0x7C: //LD A,H
        A = HL.B.h;
      break;
      case 0x7D: //LD A,L
        A = HL.B.l;
      break;
      case 0x7E: //LD A,(HL)
        A = readmemory(HL.W);
      break;
      case 0x80: //ADD B
        gbz80_add(BC.B.h);   
      break;
      case 0x81: //ADD C
        gbz80_add(BC.B.l);         
      break;
      case 0x82: //ADD D
        gbz80_add(DE.B.h);         
      break;
      case 0x83: //ADD E
        gbz80_add(DE.B.l);       
      break;
      case 0x84: //ADD H
        gbz80_add(HL.B.h);          
      break;
      case 0x85: //ADD L
        gbz80_add(HL.B.l);            
      break;
      case 0x86: //ADD (HL)
        gbz80_add(readmemory(HL.W));          
      break;
      case 0x87: //ADD A
        gbz80_add(A);              
      break;
      case 0x88: //ADC B
        gbz80_adc(BC.B.h); 
      break;
      case 0x89: //ADC C
        gbz80_adc(BC.B.l); 
      break;
      case 0x8A: //ADC D
        gbz80_adc(DE.B.h);  
      break;
      case 0x8B: //ADC E
        gbz80_adc(DE.B.l);  
      break;
      case 0x8C: //ADC H
        gbz80_adc(HL.B.h);  
      break;
      case 0x8D: //ADC L
        gbz80_adc(HL.B.l);   
      break;
      case 0x8E: //ADC (HL)
        gbz80_adc(readmemory(HL.W));  
      break;
      case 0x8F: //ADC A
        gbz80_adc(A); 
      break;
      case 0x90: //SUB B
        gbz80_sub(BC.B.h);
      break;
      case 0x91: //SUB C
        gbz80_sub(BC.B.l);
      break;
      case 0x92: //SUB D
        gbz80_sub(DE.B.h);
      break;
      case 0x93: //SUB E
        gbz80_sub(DE.B.l);      
      break;
      case 0x94: //SUB H
        gbz80_sub(HL.B.h);      
      break;
      case 0x95: //SUB L
        gbz80_sub(HL.B.l);      
      break;
      case 0x96: //SUB (HL)
        gbz80_sub(readmemory(HL.W));      
      break;
      case 0x97: //SUB A
        A = 0;
        flags &= 0xAE00;
        flags |= 0x4000;
        NFLAG = 1;  
      break;      
      case 0x98: //SBC B
        gbz80_sbc(BC.B.h);
      break;
      case 0x99: //SBC C
        gbz80_sbc(BC.B.l);
      break;
      case 0x9A: //SBC D
        gbz80_sbc(DE.B.h);
      break;
      case 0x9B: //SBC E
        gbz80_sbc(DE.B.l);
      break;
      case 0x9C: //SBC H
        gbz80_sbc(HL.B.h);
      break;
      case 0x9D: //SBC L
        gbz80_sbc(HL.B.l);
      break;
      case 0x9E: //SBC (HL)
        gbz80_sbc(readmemory(HL.W));
      break;            
      case 0x9F: //SBC A
        gbz80_sbc(A);
      break;
      case 0xA0: //AND B
        gbz80_and(BC.B.h);
      break;
      case 0xA1: //AND C
        gbz80_and(BC.B.l);
      break;
      case 0xA2: //AND D
        gbz80_and(DE.B.h);
      break;
      case 0xA3: //AND E
        gbz80_and(DE.B.l);
      break;
      case 0xA4: //AND H
        gbz80_and(HL.B.h);
      break;
      case 0xA5: //AND L
        gbz80_and(HL.B.l);
      break;
      case 0xA6: //AND (HL)
        gbz80_and(readmemory(HL.W));
      break;
      case 0xA7: //AND A
        gbz80_and(A);
      break;
      case 0xA8: //XOR B
        gbz80_xor(BC.B.h); 
      break;
      case 0xA9: //XOR C
        gbz80_xor(BC.B.l); 
      break;
      case 0xAA: //XOR D
        gbz80_xor(DE.B.h); 
      break;
      case 0xAB: //XOR E
        gbz80_xor(DE.B.l); 
      break;
      case 0xAC: //XOR H
        gbz80_xor(HL.B.h); 
      break;
      case 0xAD: //XOR L
        gbz80_xor(HL.B.l); 
      break;
      case 0xAE: //XOR (HL)
        gbz80_xor(readmemory(HL.W)); 
      break;
      case 0xAF: //XOR A
        gbz80_xor(A);
      break;
      case 0xB0: //OR B
        gbz80_or(BC.B.h);
      break;
      case 0xB1: //OR C
        gbz80_or(BC.B.l);
      break;
      case 0xB2: //OR D
        gbz80_or(DE.B.h);
      break;
      case 0xB3: //OR E
        gbz80_or(DE.B.l);
      break;
      case 0xB4: //OR H
        gbz80_or(HL.B.h);
      break;
      case 0xB5: //OR L
        gbz80_or(HL.B.l);
      break;
      case 0xB6: //OR (HL)
        gbz80_or(readmemory(HL.W));
      break;
      case 0xB7: //OR A
        gbz80_or(A);
      break;
      case 0xB8: //CP B
        gbz80_cp(BC.B.h);
      break;
      case 0xB9: //CP C
        gbz80_cp(BC.B.l);
      break;   
      case 0xBA: //CP D
        gbz80_cp(DE.B.h);
      break;   
      case 0xBB: //CP E
        gbz80_cp(DE.B.l);
      break;
      case 0xBC: //CP H
        gbz80_cp(HL.B.h);
      break;
      case 0xBD: //CP L
        gbz80_cp(HL.B.l);
      break;
      case 0xBE: //CP (HL)
        gbz80_cp(readmemory(HL.W));
      break;
      case 0xBF: //CP A
        flags = 0x4000; // set zero flag
        NFLAG = 1;
      break;
      case 0xC0: //RET NZ
        if(!(flags&0x4000)) 
        { 
           cur_cycle = 20; 
           POP(PC.B.l); 
           POP(PC.B.h); 
        }
      break;
      case 0xC1: //POP BC
        POP(BC.B.l); 
        POP(BC.B.h);    
      break;
      case 0xC2: //JP NZ,xxxx
        if(!(flags&0x4000)) 
        { 
           cur_cycle = 16; 
           PC.W = readword(PC.W);  
        } else 
           PC.W += 2;
      break;
      case 0xC3: //JP xxxx
         PC.W = readword(PC.W);
      break;
      case 0xC4: //CALL NZ,xxxx
        if(!(flags&0x4000)) 
        { 
           cur_cycle = 24; 
           tempreg.W = readword(PC.W);
           PC.W += 2;   
           PUSH(PC.B.h); 
           PUSH(PC.B.l); 
           PC.W = tempreg.W;  
        } else 
           PC.W+=2;
      break;
      case 0xC5: //PUSH BC
        PUSH(BC.B.h); 
        PUSH(BC.B.l);      
      break;
      case 0xC6: //ADD xx
        gbz80_add(readopcode(PC.W++)); 
      break;
      case 0xC7: //RST 0
        PUSH(PC.B.h); 
        PUSH(PC.B.l); 
        PC.W=0x0000; 
      break;
      case 0xC8: //RET Z
        if(flags&0x4000) 
        { 
           cur_cycle = 20; 
           POP(PC.B.l); 
           POP(PC.B.h);         
        }
      break;
      case 0xC9: //RET
        POP(PC.B.l); 
        POP(PC.B.h);    
      break;
      case 0xCA: //JP Z,xxxx
        if(flags&0x4000) 
        { 
           cur_cycle = 16; 
           PC.W = readword(PC.W);
        } else 
           PC.W+=2;
      break;
      case 0xCB: //EXTENDED
        opcode = readopcode(PC.W++);
        cur_cycle =  CB_cycles[opcode];
        switch(opcode)
        {
        case 0x00: //RLC B
          gbz80_rlc(&BC.B.h);
        break;
        case 0x01: //RLC C
          gbz80_rlc(&BC.B.l);
        break;
        case 0x02: //RLC D
          gbz80_rlc(&DE.B.h);        
        break;
        case 0x03: //RLC E
          gbz80_rlc(&DE.B.l);        
        break;
        case 0x04: //RLC H
          gbz80_rlc(&HL.B.h);        
        break;
        case 0x05: //RLC L
          gbz80_rlc(&HL.B.l);        
        break;
        case 0x06: //RLC (HL)
          temp = readmemory(HL.W);
          gbz80_rlc(&temp); 
          writememory(HL.W,temp); 
        break;
        case 0x07: //RLC A
          gbz80_rlc(&A);
        break;
        case 0x08: //RRC B
          gbz80_rrc(&BC.B.h);
        break;
        case 0x09: //RRC C
          gbz80_rrc(&BC.B.l);
        break;
        case 0x0A: //RRC D
          gbz80_rrc(&DE.B.h);
        break;
        case 0x0B: //RRC E
          gbz80_rrc(&DE.B.l);
        break;
        case 0x0C: //RRC H
          gbz80_rrc(&HL.B.h);
        break;
        case 0x0D: //RRC L
          gbz80_rrc(&HL.B.l);
        break;
        case 0x0E: //RRC (HL)
          temp = readmemory(HL.W);
          gbz80_rrc(&temp); 
          writememory(HL.W,temp);
        break;
        case 0x0F: //RRC A
          gbz80_rrc(&A);
        break;
        case 0x10: //RL B
          gbz80_rl(&BC.B.h);
        break;
        case 0x11: //RL C
          gbz80_rl(&BC.B.l);
        break;
        case 0x12: //RL D
          gbz80_rl(&DE.B.h);
        break;
        case 0x13: //RL E
          gbz80_rl(&DE.B.l);
        break;
        case 0x14: //RL H
          gbz80_rl(&HL.B.h);
        break;
        case 0x15: //RL L
          gbz80_rl(&HL.B.l);
        break;
        case 0x16: //RL (HL)
          temp = readmemory(HL.W);
          gbz80_rl(&temp); 
          writememory(HL.W,temp);
        break;
        case 0x17: //RL A
          gbz80_rl(&A);
        break;
        case 0x18: //RR B
          gbz80_rr(&BC.B.h);
        break;
        case 0x19: //RR C
          gbz80_rr(&BC.B.l);
        break;
        case 0x1A: //RR D
          gbz80_rr(&DE.B.h);
        break;
        case 0x1B: //RR E
          gbz80_rr(&DE.B.l);
        break;
        case 0x1C: //RR H
          gbz80_rr(&HL.B.h);
        break;
        case 0x1D: //RR L
          gbz80_rr(&HL.B.l);
        break;
        case 0x1E: //RR (HL)
          temp = readmemory(HL.W);
          gbz80_rr(&temp); 
          writememory(HL.W,temp);
        break;
        case 0x1F: //RR A
          gbz80_rr(&A);
        break;
        case 0x20: //SLA B
          gbz80_sla(&BC.B.h);
        break;
        case 0x21: //SLA C
          gbz80_sla(&BC.B.l);
        break;
        case 0x22: //SLA D
          gbz80_sla(&DE.B.h);
        break;
        case 0x23: //SLA E
          gbz80_sla(&DE.B.l);
        break;
        case 0x24: //SLA H
          gbz80_sla(&HL.B.h);
        break;
        case 0x25: //SLA L
          gbz80_sla(&HL.B.l);
        break;
        case 0x26: //SLA (HL)
          temp = readmemory(HL.W);
          gbz80_sla(&temp); 
          writememory(HL.W,temp);
        break;
        case 0x27: //SLA A
          gbz80_sla(&A);
        break;
        case 0x28: //SRA B
          gbz80_sra(&BC.B.h);
        break;  
        case 0x29: //SRA C
          gbz80_sra(&BC.B.l);
        break;  
        case 0x2A: //SRA D
          gbz80_sra(&DE.B.h);
        break;     
        case 0x2B: //SRA E   
          gbz80_sra(&DE.B.l);
        break;
        case 0x2C: //SRA H
          gbz80_sra(&HL.B.h);
        break;   
        case 0x2D: //SRA L
          gbz80_sra(&HL.B.l);
        break;   
        case 0x2E: //SRA (HL)
          temp = readmemory(HL.W);
          gbz80_sra(&temp); 
          writememory(HL.W,temp);
        break;   
        case 0x2F: //SRA A
          gbz80_sra(&A);
        break;   
        case 0x30: //SWAP B
          gbz80_swap(&BC.B.h);
        break;   
        case 0x31: //SWAP C
          gbz80_swap(&BC.B.l);
        break;   
        case 0x32: //SWAP D
          gbz80_swap(&DE.B.h);
        break;   
        case 0x33: //SWAP E
          gbz80_swap(&DE.B.l);
        break;   
        case 0x34: //SWAP H
          gbz80_swap(&HL.B.h);
        break;   
        case 0x35: //SWAP L
          gbz80_swap(&HL.B.l);
        break;   
        case 0x36: //SWAP (HL)
          temp = readmemory(HL.W);
          gbz80_swap(&temp); 
          writememory(HL.W,temp);
        break;   
        case 0x37: //SWAP A
          gbz80_swap(&A);
        break;  
        case 0x38: //SRL B
          gbz80_srl(&BC.B.h);
        break; 
        case 0x39: //SRL C
          gbz80_srl(&BC.B.l);
        break; 
        case 0x3A: //SRL D
          gbz80_srl(&DE.B.h);
        break; 
        case 0x3B: //SRL E
          gbz80_srl(&DE.B.l);
        break; 
        case 0x3C: //SRL H
          gbz80_srl(&HL.B.h);
        break; 
        case 0x3D: //SRL L
          gbz80_srl(&HL.B.l);
        break; 
        case 0x3E: //SRL (HL)
          temp = readmemory(HL.W);
          gbz80_srl(&temp); 
          writememory(HL.W,temp);
        break; 
        case 0x3F: //SRL A
          gbz80_srl(&A);
        break; 
        case 0x40: //BIT 0,B
          gbz80_bit(BC.B.h,0);
        break; 
        case 0x41: //BIT 0,C
          gbz80_bit(BC.B.l,0);
        break; 
        case 0x42: //BIT 0,D
          gbz80_bit(DE.B.h,0);
        break; 
        case 0x43: //BIT 0,E
          gbz80_bit(DE.B.l,0);
        break; 
        case 0x44: //BIT 0,H
          gbz80_bit(HL.B.h,0);
        break; 
        case 0x45: //BIT 0,L
          gbz80_bit(HL.B.l,0);
        break; 
        case 0x46: //BIT 0,(HL)
          gbz80_bit(readmemory(HL.W),0);
        break; 
        case 0x47: //BIT 0,A
          gbz80_bit(A,0);
        break; 
        case 0x48: //BIT 1,B
          gbz80_bit(BC.B.h,1);
        break; 
        case 0x49: //BIT 1,C
          gbz80_bit(BC.B.l,1);
        break; 
        case 0x4A: //BIT 1,D
          gbz80_bit(DE.B.h,1);
        break; 
        case 0x4B: //BIT 1,E
          gbz80_bit(DE.B.l,1);
        break; 
        case 0x4C: //BIT 1,H
          gbz80_bit(HL.B.h,1);
        break; 
        case 0x4D: //BIT 1,L
          gbz80_bit(HL.B.l,1);
        break; 
        case 0x4E: //BIT 1,(HL)
          gbz80_bit(readmemory(HL.W),1);
        break; 
        case 0x4F: //BIT 1,A
          gbz80_bit(A,1);
        break; 
        case 0x50: //BIT 2,B
          gbz80_bit(BC.B.h,2);
        break; 
        case 0x51: //BIT 2,C
          gbz80_bit(BC.B.l,2);
        break; 
        case 0x52: //BIT 2,D
          gbz80_bit(DE.B.h,2);
        break; 
        case 0x53: //BIT 2,E
          gbz80_bit(DE.B.l,2);
        break; 
        case 0x54: //BIT 2,H
          gbz80_bit(HL.B.h,2);
        break; 
        case 0x55: //BIT 2,L
          gbz80_bit(HL.B.l,2);
        break; 
        case 0x56: //BIT 2,(HL)
          gbz80_bit(readmemory(HL.W),2);
        break; 
        case 0x57: //BIT 2,A
          gbz80_bit(A,2);
        break; 
        case 0x58: //BIT 3,B
          gbz80_bit(BC.B.h,3);
        break; 
        case 0x59: //BIT 3,C
          gbz80_bit(BC.B.l,3);
        break; 
        case 0x5A: //BIT 3,D
          gbz80_bit(DE.B.h,3);
        break; 
        case 0x5B: //BIT 3,E
          gbz80_bit(DE.B.l,3);
        break; 
        case 0x5C: //BIT 3,H
          gbz80_bit(HL.B.h,3);
        break; 
        case 0x5D: //BIT 3,L
          gbz80_bit(HL.B.l,3);
        break; 
        case 0x5E: //BIT 3,(HL)
          gbz80_bit(readmemory(HL.W),3);
        break; 
        case 0x5F: //BIT 3,A
          gbz80_bit(A,3);
        break;
        case 0x60: //BIT 4,B
          gbz80_bit(BC.B.h,4);
        break; 
        case 0x61: //BIT 4,C
          gbz80_bit(BC.B.l,4);
        break; 
        case 0x62: //BIT 4,D
          gbz80_bit(DE.B.h,4);
        break; 
        case 0x63: //BIT 4,E
          gbz80_bit(DE.B.l,4);
        break; 
        case 0x64: //BIT 4,H
          gbz80_bit(HL.B.h,4);
        break; 
        case 0x65: //BIT 4,L
          gbz80_bit(HL.B.l,4);
        break; 
        case 0x66: //BIT 4,(HL)
          gbz80_bit(readmemory(HL.W),4);
        break; 
        case 0x67: //BIT 4,A
          gbz80_bit(A,4);
        break; 
        case 0x68: //BIT 5,B
          gbz80_bit(BC.B.h,5);
        break; 
        case 0x69: //BIT 5,C
          gbz80_bit(BC.B.l,5);
        break; 
        case 0x6A: //BIT 5,D
          gbz80_bit(DE.B.h,5);
        break; 
        case 0x6B: //BIT 5,E
          gbz80_bit(DE.B.l,5);
        break; 
        case 0x6C: //BIT 5,H
          gbz80_bit(HL.B.h,5);
        break; 
        case 0x6D: //BIT 5,L
          gbz80_bit(HL.B.l,5);
        break; 
        case 0x6E: //BIT 5,(HL)
          gbz80_bit(readmemory(HL.W),5);
        break; 
        case 0x6F: //BIT 5,A
          gbz80_bit(A,5);
        break;       
        case 0x70: //BIT 6,B
          gbz80_bit(BC.B.h,6);
        break; 
        case 0x71: //BIT 6,C
          gbz80_bit(BC.B.l,6);
        break; 
        case 0x72: //BIT 6,D
          gbz80_bit(DE.B.h,6);
        break;
        case 0x73: //BIT 6,E
          gbz80_bit(DE.B.l,6);
        break; 
        case 0x74: //BIT 6,H
          gbz80_bit(HL.B.h,6);
        break; 
        case 0x75: //BIT 6,L
          gbz80_bit(HL.B.l,6);
        break; 
        case 0x76: //BIT 6,(HL)
          gbz80_bit(readmemory(HL.W),6);
        break; 
        case 0x77: //BIT 6,A
          gbz80_bit(A,6);
        break;
        case 0x78: //BIT 7,B
          gbz80_bit(BC.B.h,7);
        break; 
        case 0x79: //BIT 7,C
          gbz80_bit(BC.B.l,7);
        break; 
        case 0x7A: //BIT 7,D
          gbz80_bit(DE.B.h,7);
        break;
        case 0x7B: //BIT 7,E
          gbz80_bit(DE.B.l,7);
        break; 
        case 0x7C: //BIT 7,H
          gbz80_bit(HL.B.h,7);
        break; 
        case 0x7D: //BIT 7,L
          gbz80_bit(HL.B.l,7);
        break; 
        case 0x7E: //BIT 7,(HL)
          gbz80_bit(readmemory(HL.W),7);
        break; 
        case 0x7F: //BIT 7,A
          gbz80_bit(A,7);
        break;   
        case 0x80: //RES 0,B
          BC.B.h &= 0xFE;
        break;     
        case 0x81: //RES 0,C
          BC.B.l &= 0xFE;
        break; 
        case 0x82: //RES 0,D
          DE.B.h &= 0xFE;
        break; 
        case 0x83: //RES 0,E
          DE.B.l &= 0xFE;
        break; 
        case 0x84: //RES 0,H
          HL.B.h &= 0xFE;
        break; 
        case 0x85: //RES 0,L
          HL.B.l &= 0xFE;
        break; 
        case 0x86: //RES 0,(HL)
          writememory(HL.W,readmemory(HL.W)&0xFE);
        break; 
        case 0x87: //RES 0,A
          A &= 0xFE;
        break; 
        case 0x88: //RES 1,B
          BC.B.h &= 0xFD;
        break;     
        case 0x89: //RES 1,C
          BC.B.l &= 0xFD;
        break; 
        case 0x8A: //RES 1,D
          DE.B.h &= 0xFD;
        break; 
        case 0x8B: //RES 1,E
          DE.B.l &= 0xFD;
        break; 
        case 0x8C: //RES 1,H
          HL.B.h &= 0xFD;
        break; 
        case 0x8D: //RES 1,L
          HL.B.l &= 0xFD;
        break; 
        case 0x8E: //RES 1,(HL)
          writememory(HL.W,readmemory(HL.W)&0xFD);
        break; 
        case 0x8F: //RES 1,A
          A &= 0xFD;
        break;
        case 0x90: //RES 2,B
          BC.B.h &= 0xFB;
        break;     
        case 0x91: //RES 2,C
          BC.B.l &= 0xFB;
        break; 
        case 0x92: //RES 2,D
          DE.B.h &= 0xFB;
        break; 
        case 0x93: //RES 2,E
          DE.B.l &= 0xFB;
        break; 
        case 0x94: //RES 2,H
          HL.B.h &= 0xFB;
        break; 
        case 0x95: //RES 2,L
          HL.B.l &= 0xFB;
        break; 
        case 0x96: //RES 2,(HL)
          writememory(HL.W,readmemory(HL.W)&0xFB);
        break; 
        case 0x97: //RES 2,A
          A &= 0xFB;
        break;
        case 0x98: //RES 3,B
          BC.B.h &= 0xF7;
        break;     
        case 0x99: //RES 3,C
          BC.B.l &= 0xF7;
        break; 
        case 0x9A: //RES 3,D
          DE.B.h &= 0xF7;
        break; 
        case 0x9B: //RES 3,E
          DE.B.l &= 0xF7;
        break; 
        case 0x9C: //RES 3,H
          HL.B.h &= 0xF7;
        break; 
        case 0x9D: //RES 3,L
          HL.B.l &= 0xF7;
        break; 
        case 0x9E: //RES 3,(HL)
          writememory(HL.W,readmemory(HL.W)&0xF7);
        break; 
        case 0x9F: //RES 3,A
          A &= 0xF7;
        break;
        case 0xA0: //RES 4,B
          BC.B.h &= 0xEF;
        break;     
        case 0xA1: //RES 4,C
          BC.B.l &= 0xEF;
        break; 
        case 0xA2: //RES 4,D
          DE.B.h &= 0xEF;
        break; 
        case 0xA3: //RES 4,E
          DE.B.l &= 0xEF;
        break; 
        case 0xA4: //RES 4,H
          HL.B.h &= 0xEF;
        break; 
        case 0xA5: //RES 4,L
          HL.B.l &= 0xEF;
        break; 
        case 0xA6: //RES 4,(HL)
          writememory(HL.W,readmemory(HL.W)&0xEF);
        break; 
        case 0xA7: //RES 4,A
          A &= 0xEF;
        break;
        case 0xA8: //RES 5,B
          BC.B.h &= 0xDF;
        break;     
        case 0xA9: //RES 5,C
          BC.B.l &= 0xDF;
        break; 
        case 0xAA: //RES 5,D
          DE.B.h &= 0xDF;
        break; 
        case 0xAB: //RES 5,E
          DE.B.l &= 0xDF;
        break; 
        case 0xAC: //RES 5,H
          HL.B.h &= 0xDF;
        break; 
        case 0xAD: //RES 5,L
          HL.B.l &= 0xDF;
        break; 
        case 0xAE: //RES 5,(HL)
          writememory(HL.W,readmemory(HL.W)&0xDF);
        break; 
        case 0xAF: //RES 5,A
          A &= 0xDF;
        break; 
        case 0xB0: //RES 6,B
          BC.B.h &= 0xBF;
        break;     
        case 0xB1: //RES 6,C
          BC.B.l &= 0xBF;
        break; 
        case 0xB2: //RES 6,D
          DE.B.h &= 0xBF;
        break; 
        case 0xB3: //RES 6,E
          DE.B.l &= 0xBF;
        break; 
        case 0xB4: //RES 6,H
          HL.B.h &= 0xBF;
        break; 
        case 0xB5: //RES 6,L
          HL.B.l &= 0xBF;
        break; 
        case 0xB6: //RES 6,(HL)
          writememory(HL.W,readmemory(HL.W)&0xBF);
        break; 
        case 0xB7: //RES 6,A
          A &= 0xBF;
        break;  
        case 0xB8: //RES 7,B
          BC.B.h &= 0x7F;
        break;     
        case 0xB9: //RES 7,C
          BC.B.l &= 0x7F;
        break; 
        case 0xBA: //RES 7,D
          DE.B.h &= 0x7F;
        break; 
        case 0xBB: //RES 7,E
          DE.B.l &= 0x7F;
        break; 
        case 0xBC: //RES 7,H
          HL.B.h &= 0x7F;
        break; 
        case 0xBD: //RES 7,L
          HL.B.l &= 0x7F;
        break; 
        case 0xBE: //RES 7,(HL)
          writememory(HL.W,readmemory(HL.W)&0x7F);
        break; 
        case 0xBF: //RES 7,A
          A &= 0x7F;
        break;   
        case 0xC0: //SET 0,B
          BC.B.h |= 0x01;
        break;  
        case 0xC1: //SET 0,C
          BC.B.l |= 0x01;
        break;
        case 0xC2: //SET 0,D
          DE.B.h |= 0x01;
        break;
        case 0xC3: //SET 0,E
          DE.B.l |= 0x01;
        break;
        case 0xC4: //SET 0,H
          HL.B.h |= 0x01;
        break;
        case 0xC5: //SET 0,L
          HL.B.l |= 0x01;
        break;
        case 0xC6: //SET 0,(HL)
          writememory(HL.W,readmemory(HL.W)|0x01);
        break;
        case 0xC7: //SET 0,A
          A |= 0x01;
        break;
        case 0xC8: //SET 1,B
          BC.B.h |= 0x02;
        break;  
        case 0xC9: //SET 1,C
          BC.B.l |= 0x02;
        break;
        case 0xCA: //SET 1,D
          DE.B.h |= 0x02;
        break;
        case 0xCB: //SET 1,E
          DE.B.l |= 0x02;
        break;
        case 0xCC: //SET 1,H
          HL.B.h |= 0x02;
        break;
        case 0xCD: //SET 1,L
          HL.B.l |= 0x02;
        break;
        case 0xCE: //SET 1,(HL)
          writememory(HL.W,readmemory(HL.W)|0x02);
        break;
        case 0xCF: //SET 1,A
          A |= 0x02;
        break;
        case 0xD0: //SET 2,B
          BC.B.h |= 0x04;
        break;  
        case 0xD1: //SET 2,C
          BC.B.l |= 0x04;
        break;
        case 0xD2: //SET 2,D
          DE.B.h |= 0x04;
        break;
        case 0xD3: //SET 2,E
          DE.B.l |= 0x04;
        break;
        case 0xD4: //SET 2,H
          HL.B.h |= 0x04;
        break;
        case 0xD5: //SET 2,L
          HL.B.l |= 0x04;
        break;
        case 0xD6: //SET 2,(HL)
          writememory(HL.W,readmemory(HL.W)|0x04);
        break;
        case 0xD7: //SET 2,A
          A |= 0x04;
        break;
        case 0xD8: //SET 3,B
          BC.B.h |= 0x08;
        break;  
        case 0xD9: //SET 3,C
          BC.B.l |= 0x08;
        break;
        case 0xDA: //SET 3,D
          DE.B.h |= 0x08;
        break;
        case 0xDB: //SET 3,E
          DE.B.l |= 0x08;
        break;
        case 0xDC: //SET 3,H
          HL.B.h |= 0x08;
        break;
        case 0xDD: //SET 3,L
          HL.B.l |= 0x08;
        break;
        case 0xDE: //SET 3,(HL)
          writememory(HL.W,readmemory(HL.W)|0x08);
        break;
        case 0xDF: //SET 3,A
          A |= 0x08;
        break;
        case 0xE0: //SET 4,B
          BC.B.h |= 0x10;
        break;  
        case 0xE1: //SET 4,C
          BC.B.l |= 0x10;
        break;
        case 0xE2: //SET 4,D
          DE.B.h |= 0x10;
        break;
        case 0xE3: //SET 4,E
          DE.B.l |= 0x10;
        break;
        case 0xE4: //SET 4,H
          HL.B.h |= 0x10;
        break;
        case 0xE5: //SET 4,L
          HL.B.l |= 0x10;
        break;
        case 0xE6: //SET 4,(HL)
          writememory(HL.W,readmemory(HL.W)|0x10);
        break;
        case 0xE7: //SET 4,A
          A |= 0x10;
        break;
        case 0xE8: //SET 5,B
          BC.B.h |= 0x20;
        break;  
        case 0xE9: //SET 5,C
          BC.B.l |= 0x20;
        break;
        case 0xEA: //SET 5,D
          DE.B.h |= 0x20;
        break;
        case 0xEB: //SET 5,E
          DE.B.l |= 0x20;
        break;
        case 0xEC: //SET 5,H
          HL.B.h |= 0x20;
        break;
        case 0xED: //SET 5,L
          HL.B.l |= 0x20;
        break;
        case 0xEE: //SET 5,(HL)
          writememory(HL.W,readmemory(HL.W)|0x20);
        break;
        case 0xEF: //SET 5,A
          A |= 0x20;
        break;
        case 0xF0: //SET 6,B
          BC.B.h |= 0x40;
        break;  
        case 0xF1: //SET 6,C
          BC.B.l |= 0x40;
        break;
        case 0xF2: //SET 6,D
          DE.B.h |= 0x40;
        break;
        case 0xF3: //SET 6,E
          DE.B.l |= 0x40;
        break;
        case 0xF4: //SET 6,H
          HL.B.h |= 0x40;
        break;
        case 0xF5: //SET 6,L
          HL.B.l |= 0x40;
        break;
        case 0xF6: //SET 6,(HL)
          writememory(HL.W,readmemory(HL.W)|0x40);
        break;
        case 0xF7: //SET 6,A
          A |= 0x40;
        break;
        case 0xF8: //SET 7,B
          BC.B.h |= 0x80;
        break;  
        case 0xF9: //SET 7,C
          BC.B.l |= 0x80;
        break;
        case 0xFA: //SET 7,D
          DE.B.h |= 0x80;
        break;
        case 0xFB: //SET 7,E
          DE.B.l |= 0x80;
        break;
        case 0xFC: //SET 7,H
          HL.B.h |= 0x80;
        break;
        case 0xFD: //SET 7,L
          HL.B.l |= 0x80;
        break;
        case 0xFE: //SET 7,(HL)
          writememory(HL.W,readmemory(HL.W)|0x80);
        break;
        case 0xFF: //SET 7,A
          A |= 0x80;
        break;
        }
      // end extended
      break;
      case 0xCC: //CALL Z,xxxx
        if(flags&0x4000)
        { 
           cur_cycle = 24; 
           tempreg.W = readword(PC.W);
           PC.W += 2;   
           PUSH(PC.B.h); 
           PUSH(PC.B.l); 
           PC.W = tempreg.W;  
        } else 
           PC.W+=2;
      break;
      case 0xCD: //CALL xxxx
        tempreg.W = readword(PC.W);
        PC.W += 2;   
        PUSH(PC.B.h); 
        PUSH(PC.B.l); 

        PC.W = tempreg.W;  
      break;
      case 0xCE: //ADC xx
        gbz80_adc(readopcode(PC.W++)); 
      break;
      case 0xCF: //RST 8
        PUSH(PC.B.h); 
        PUSH(PC.B.l); 

        PC.W=0x0008; 
      break;
      case 0xD0: //RET NC
        if(!(flags&0x0100)) 
        { 
           cur_cycle = 20; 
           POP(PC.B.l); 
           POP(PC.B.h); 
        }
      break;
      case 0xD1: //POP DE
        POP(DE.B.l); 
        POP(DE.B.h);     
      break;
      case 0xD2: //JP NC,xxxx
        if(!(flags&0x0100)) 
        { 
           cur_cycle = 16; 
           PC.W = readword(PC.W);
        } else
           PC.W += 2; 
      break;
      case 0xD4: //CALL NC,xxxx
        if(!(flags&0x0100)) 
        { 
           cur_cycle = 24; 
           tempreg.W = readword(PC.W);
           PC.W += 2;   
           PUSH(PC.B.h); 
           PUSH(PC.B.l); 

           PC.W = tempreg.W;   
        } else 
           PC.W+=2;
      break;
      case 0xD5: //PUSH DE
       PUSH(DE.B.h); 
       PUSH(DE.B.l);     
      break;
      case 0xD6: //SUB xx
        gbz80_sub(readopcode(PC.W++));  
      break;
      case 0xD7: //RST 10
        PUSH(PC.B.h); 
        PUSH(PC.B.l); 

        PC.W=0x0010; 
      break;
      case 0xD8: //RET C
        if(flags&0x0100) 
        { 
           cur_cycle = 20; 
           POP(PC.B.l); 
           POP(PC.B.h);      
        }
      break;
      case 0xD9: //RETI // Return, enable interrupts
        POP(PC.B.l); 
        POP(PC.B.h);   
        GB->IME = 1;
      break;
      case 0xDA: //JP C,xxxx
        if(flags&0x0100) 
        { 
           cur_cycle = 16; 
           PC.W = readword(PC.W);
        } else 
           PC.W += 2;
      break;
      case 0xDC: //CALL C,xxxx
        if(flags&0x0100) 
        { 
           cur_cycle = 24; 
           tempreg.W = readword(PC.W);
           PC.W += 2;   
           PUSH(PC.B.h); 
           PUSH(PC.B.l); 
          
           PC.W = tempreg.W;  
        } else 
           PC.W+=2;
      break;
      case 0xDE: //SBC xx
        gbz80_sbc(readopcode(PC.W++));
      break;
      case 0xDF: //RST 18
        PUSH(PC.B.h); 
        PUSH(PC.B.l); 
      
        PC.W=0x0018; 
      break;
      case 0xE0: //LD ($FF00+xx),A "LDH (x),A"
        writememory(0xFF00+readopcode(PC.W++),A);
      break;
      case 0xE1: //POP HL
       POP(HL.B.l); 
       POP(HL.B.h); 
      break;
      case 0xE2: //LD ($FF00+C),A
        writememory(0xFF00+BC.B.l,A);
      break;
      case 0xE5: //PUSH HL
       PUSH(HL.B.h); 
       PUSH(HL.B.l);
       //PUSH(HL.W);       
      break;
      case 0xE6: //AND xx
        gbz80_and(readopcode(PC.W++));
      break;
      case 0xE7: //RST 20
        PUSH(PC.B.h); 
        PUSH(PC.B.l); 
     
        PC.W=0x0020; 
      break;
      case 0xE8: //ADD SP,xx
        gbz80_addSP(&SP.W,readopcode(PC.W++));
      break;
      case 0xE9: //JP HL "LD PC,HL"
        PC.W = HL.W;
      break;
      case 0xEA: //LD (xxxx),A
        writememory(readword(PC.W),A);
        PC.W += 2;
      break;
      case 0xEE: //XOR xx
        gbz80_xor(readopcode(PC.W++));
      break;
      case 0xEF: //RST 28
        PUSH(PC.B.h); 
        PUSH(PC.B.l); 
      
        PC.W=0x0028; 
      break;
      case 0xF0: //LD A,($FF00+xx) "LDH A,(x)"
        A = readmemory(0xFF00+readopcode(PC.W++));
      break;
      case 0xF1: //POP AF
       POP(F);
       POP(A); 
       flags = 0;
       flags |= (F&0x10)<<4; //carry
       flags |= (F&0x20)<<7; //half-carry
       flags |= (F&0x80)<<7; //zero
       NFLAG = (F&0x40?1:0);
      break;
      case 0xF2: //LD A,($FF00+C)
        A = readmemory(0xFF00+BC.B.l);
      break;
      case 0xF3: //DI disable interrupts
        GB->IME = GB->EI_count = 0;
      break;
      case 0xF5: //PUSH AF
        PUSH(A); 
        F = 0;
        F |= (NFLAG<<6);
        F |= ((flags&0x4000)>>7);    
        F |= ((flags&0x1000)>>7);     
        F |= ((flags&0x0100)>>4);              
        PUSH(F);
      break;
      case 0xF6: //OR xx
        gbz80_or(readopcode(PC.W++));
      break;
      case 0xF7: //RST 30
        PUSH(PC.B.h); 
        PUSH(PC.B.l);
         
        PC.W=0x0030; 
      break;
      case 0xF8: //LD HL,SP+xx
        tempreg.W = SP.W;
        gbz80_addSP(&SP.W,readopcode(PC.W++));
        HL.W = SP.W;
        SP.W = tempreg.W;
      break;
      case 0xF9: //LD SP,HL
        SP.W = HL.W;
      break;
      case 0xFA: //LD A,(xxxx)
        A = readmemory(readword(PC.W));
        PC.W += 2;
      break;
      case 0xFB: //EI enable interrupts after next instruction
         GB->EI_count = 1;
      break;
      case 0xFE: //CP xx
        gbz80_cp(readopcode(PC.W++));         
      break;
      case 0xFF: //RST 38
        PUSH(PC.B.h); 
        PUSH(PC.B.l); 
    
        PC.W=0x0038; 
      break;
      default:
        if(unk_opcode_option)
        {
           char buffer[100];
           sprintf(buffer,"%s PC:%x, %s:%x",str_table[ERROR_UNK_OPCODE],PC.W,str_table[ERROR_OPCODE],opcode);
           debug_print(buffer);  

           emulating = false;
           ++frames;
        }
      break;
   }

