/*
GEST - Gameboy emulator
Copyright (C) 2003-2004 TM

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef SOUND_H
#define SOUND_H

#include "types.h"
#include "debug.h"
#include <fmod.h>

#define NR10 0xff10
#define NR11 0xff11
#define NR12 0xff12
#define NR13 0xff13
#define NR14 0xff14
#define NR21 0xff16
#define NR22 0xff17
#define NR23 0xff18
#define NR24 0xff19
#define NR30 0xff1a
#define NR31 0xff1b
#define NR32 0xff1c
#define NR33 0xff1d
#define NR34 0xff1e
#define NR41 0xff20
#define NR42 0xff21
#define NR43 0xff22
#define NR44 0xff23
#define NR50 0xff24
#define NR51 0xff25
#define NR52 0xff26

#define SND_EN_CH1 1
#define SND_EN_CH2 2
#define SND_EN_CH3 4
#define SND_EN_CH4 8

extern int sound_enable;

void sound_register(unsigned short,byte);
void sound_event();

void sound_reset();

#define LOWPASS_LEVEL1 1
#define LOWPASS_LEVEL2 2
extern int sound_lowpass;

extern int sound_reverse_stereo;
extern int sound_volume;

extern int CYCLES_SOUND;
//extern int cycles_sound;
extern FSOUND_SAMPLE* FSbuffer;
extern int sound_buffer_total_len;
extern int sound_quality;
extern int channel_n;
extern int system_sound_on;

extern int sound_on;
extern int sound_index;
extern int sound_buffer_index;
extern int sound_balance;
extern int sound_level1;
extern int sound_level2;
extern int sound_digital;
extern byte sound_wave_pattern[4][32];
extern byte sound_buffer[4][735];
extern signed short final_wave[1470];

extern int channel1_on;
extern int channel1_ATL;
extern int channel1_skip;
extern int channel1_continue;
extern int channel1_sweepATL;
extern int channel1_sweepATLreload;
extern int channel1_sweepdir;
extern int channel1_sweepsteps;
extern int channel1_envelopevolume;
extern int channel1_envelopeATL;
extern int channel1_envelopeATLreload;
extern int channel1_envelopedir;
extern int channel1_index;
extern byte* channel1_wave;

extern int channel2_on;
extern int channel2_ATL;
extern int channel2_skip;
extern int channel2_continue;
extern int channel2_envelopevolume;
extern int channel2_envelopeATL;
extern int channel2_envelopeATLreload;
extern int channel2_envelopedir;
extern int channel2_index;
extern byte* channel2_wave;

extern int channel3_on;
extern int channel3_continue;
extern int channel3_ATL;
extern int channel3_skip;
extern int channel3_index;
extern int channel3_last;
extern int channel3_outputlevel;

extern int channel4_on;
extern int channel4_clock;
extern int channel4_ATL;
extern int channel4_skip;
extern int channel4_index;
extern int channel4_shiftright;
extern int channel4_shiftskip;
extern int channel4_shiftindex;
extern int channel4_Nsteps;
extern int channel4_countdown;
extern int channel4_continue;
extern int channel4_envelopevolume;
extern int channel4_envelopeATL;
extern int channel4_envelopedir;
extern int channel4_envelopeATLreload;

#endif
